include	clib.inc
include	io.inc
include	dir.inc
include	stdio.inc
include	string.inc

	extrn	_argv:dword

_DATA	SEGMENT

extini	db	'.ini',0

_DATA	ENDS

_TEXT	SEGMENT

next_word PROC
	inc	di
	dec	cx
	jnz	first_word
	test	ax,ax
	ret
next_word ENDP

first_word PROC
	mov	al,[di]
	cmp	al,' '
	je	next_word
	cmp	al,9
	je	next_word
	ret
first_word ENDP

_TEXT	ENDS

PPROC	inisection, section:dword, inifile:dword
local	fname[WMAXPATH]:byte
local	rsize:word
local	bsize:word
local	fsize:word
local	handle:word
	push	si
	push	di	; assume <program>.ini
	les	bx,_argv
	invoke	strcpy, addr fname, es:[bx]
	mov	di,ax
	invoke	setfext, dx::ax, addr extini
	cmp	word ptr inifile,0
	je	@F
	invoke	strcpy, dx::ax, inifile
    @@:
	invoke	osopen, ss::di, _A_NORMAL, M_RDONLY, A_OPEN
	mov	handle,ax
	inc	ax
	jz	inisection_eropen
	invoke	strlen, section
	mov	si,ax
	mov	di,offset _bufin
	mov	bsize,4096
	invoke	osread, handle, ss::di, bsize
	mov	fsize,ax
	jmp	inisection_init
    inisection_read:
	invoke	osread, handle, ss::di, bsize
    inisection_init:
	mov	rsize,ax
	mov	bsize,4096
	test	ax,ax
	jz	inisection_eof
	push	ds
	pop	es
	mov	cx,ax
	mov	di,offset _bufin
	cld
    inisection_start:
	mov	ax,0A5Bh	; "\n["
    inisection_scan:
	repnz	scasb
	cmp	cx,si
	ja	inisection_test
	mov	bx,di
	mov	di,offset _bufin
	test	cx,cx
	jz	inisection_read
	mov	ax,si
	mov	dx,cx
	sub	bsize,cx
	mov	si,bx
	add	dx,di
	rep	movsb
	mov	si,ax
	mov	di,dx
	jmp	inisection_read
    inisection_test:
	mov	dx,cx
	inc	dx
	cmp	dx,rsize
	je	@F
	cmp	[di-2],ah
	jne	inisection_scan
    @@:
	mov	bx,si
	cmp	byte ptr [di+bx],']'
	jne	inisection_scan
	mov	byte ptr [di+bx],0
	invoke	stricmp, ds::di, section
	mov	dx,cx
	inc	dx
	test	ax,ax
	jnz	inisection_start
	mov	si,cx
	add	di,bx
	inc	di
	cmp	fsize,4096
	jne	inisection_found
	mov	di,offset _bufin
	neg	dx
	mov	cx,0FFFFh
	mov	ax,4201h
	mov	bx,handle
	int	21h
	jc	inisection_eof
	mov	ax,3F00h
	mov	bx,handle
	mov	cx,4096
	mov	dx,di
	int	21h
	jc	inisection_eof
	mov	si,ax
    inisection_found:
	invoke	close, handle
	mov	ax,di
	mov	cx,si
	mov	dx,ds
    inisection_end:
	test	ax,ax
	pop	di
	pop	si
	ret
    inisection_eof:
	invoke	close, handle
    inisection_eropen:
	xor	ax,ax
	jmp	inisection_end
PEND	inisection

PPROC	inientry, section:DWORD, entry:DWORD, inifile:DWORD
local	quote:BYTE
	push	si
	push	di
	invoke	inisection, section, inifile
	jz	inientry_fail
	mov	di,ax		; Section found, read entries
    inientry_getentry:
	mov	ax,10
	mov	quote,ah
	mov	es,dx
	repnz	scasb		; Get next line
	test	cx,cx
	jz	inientry_fail
	mov	al,[di]
	cmp	al,'['
	je	inientry_fail
	cmp	al,';'
	je	inientry_getentry
	call	first_word	; Start of line
	jz	inientry_fail
	les	bx,entry	; Compare entry name
    inientry_cmp:
	mov	al,[di]
	mov	ah,es:[bx]
	test	ah,ah   	; match if entry name is zero
	jz	inientry_match
	or	ax,2020h
	cmp	ah,al
	jne	inientry_getentry
	inc	di
	inc	bx
	dec	cx
	jnz	inientry_cmp
    inientry_fail:
	xor	ax,ax
	cwd
	jmp	inientry_end
    inientry_match:
	call	first_word
	cmp	al,'='
	jne	inientry_getentry
	inc	di
	call	first_word	; to start of string
	jz	inientry_fail

	mov	si,di
    inientry_line:
	lodsb
	cmp	al,'"'
	jne	@F
	xor	quote,1
    @@:	cmp	al,';'
	jne	@F
	cmp	quote,1
	jne	inientry_eos
    @@:	cmp	al,0Dh
	je	inientry_eos
	cmp	al,0Ah
	je	inientry_eos
	dec	cx
	jnz	inientry_line
    inientry_eos:
	xor	ax,ax
	mov	[si-1],al
	cmp	al,[di]
	je	inientry_fail
	invoke	strtrim, ds::di
	test	ax,ax
	jz	inientry_fail
	mov	dx,ds
	mov	ax,di
    inientry_end:
	pop	di
	pop	si
	ret
PEND	inientry

	END
